## hisat2 2.0.5

=== Makefile ===
#
# Copyright 2015, Daehwan Kim <infphilo@gmail.com>
#
# This file is part of HISAT2.
#
# HISAT 2 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# HISAT 2 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with HISAT.  If not, see <http://www.gnu.org/licenses/>.
#
#
# Makefile for hisat2-align, hisat2-build, hisat2-inspect
#

INC =
GCC_PREFIX = $(shell dirname `which gcc`)
GCC_SUFFIX =
CC = $(GCC_PREFIX)/gcc$(GCC_SUFFIX)
CPP = $(GCC_PREFIX)/g++$(GCC_SUFFIX)
CXX = $(CPP)
HEADERS = $(wildcard *.h)
BOWTIE_MM = 1
BOWTIE_SHARED_MEM = 0

# Detect Cygwin or MinGW
WINDOWS = 0
CYGWIN = 0
MINGW = 0
ifneq (,$(findstring CYGWIN,$(shell uname)))
	WINDOWS = 1 
	CYGWIN = 1
	# POSIX memory-mapped files not currently supported on Windows
	BOWTIE_MM = 0
	BOWTIE_SHARED_MEM = 0
else
	ifneq (,$(findstring MINGW,$(shell uname)))
		WINDOWS = 1
		MINGW = 1
		# POSIX memory-mapped files not currently supported on Windows
		BOWTIE_MM = 0
		BOWTIE_SHARED_MEM = 0
	endif
endif

MACOS = 0
ifneq (,$(findstring Darwin,$(shell uname)))
	MACOS = 1
endif

EXTRA_FLAGS += -DPOPCNT_CAPABILITY
INC += -I third_party

MM_DEF = 

ifeq (1,$(BOWTIE_MM))
	MM_DEF = -DBOWTIE_MM
endif

SHMEM_DEF = 

ifeq (1,$(BOWTIE_SHARED_MEM))
	SHMEM_DEF = -DBOWTIE_SHARED_MEM
endif

PTHREAD_PKG =
PTHREAD_LIB = 

ifeq (1,$(MINGW))
	PTHREAD_LIB = 
else
	PTHREAD_LIB = -lpthread
endif

SEARCH_LIBS = 
BUILD_LIBS = 
INSPECT_LIBS =

ifeq (1,$(MINGW))
	BUILD_LIBS = 
	INSPECT_LIBS = 
endif

USE_SRA = 0
SRA_DEF =
SRA_LIB =
SERACH_INC = 
ifeq (1,$(USE_SRA))
	SRA_DEF = -DUSE_SRA
	SRA_LIB = -lncbi-ngs-c++-static -lngs-c++-static -lncbi-vdb-static -ldl
	SEARCH_INC += -I$(NCBI_NGS_DIR)/include -I$(NCBI_VDB_DIR)/include
	SEARCH_LIBS += -L$(NCBI_NGS_DIR)/lib64 -L$(NCBI_VDB_DIR)/lib64
endif

LIBS = $(PTHREAD_LIB)

SHARED_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
	edit.cpp gfm.cpp \
	reference.cpp ds.cpp multikey_qsort.cpp limit.cpp \
	random_source.cpp tinythread.cpp
SEARCH_CPPS = qual.cpp pat.cpp \
	read_qseq.cpp aligner_seed_policy.cpp \
	aligner_seed.cpp \
	aligner_seed2.cpp \
	aligner_sw.cpp \
	aligner_sw_driver.cpp aligner_cache.cpp \
	aligner_result.cpp ref_coord.cpp mask.cpp \
	pe.cpp aln_sink.cpp dp_framer.cpp \
	scoring.cpp presets.cpp unique.cpp \
	simple_func.cpp \
	random_util.cpp \
	aligner_bt.cpp sse_util.cpp \
	aligner_swsse.cpp outq.cpp \
	aligner_swsse_loc_i16.cpp \
	aligner_swsse_ee_i16.cpp \
	aligner_swsse_loc_u8.cpp \
	aligner_swsse_ee_u8.cpp \
	aligner_driver.cpp \
	splice_site.cpp 

BUILD_CPPS = diff_sample.cpp

HISAT2_CPPS_MAIN = $(SEARCH_CPPS) hisat2_main.cpp
HISAT2_BUILD_CPPS_MAIN = $(BUILD_CPPS) hisat2_build_main.cpp

SEARCH_FRAGMENTS = $(wildcard search_*_phase*.c)
VERSION = $(shell cat VERSION)

# Convert BITS=?? to a -m flag
BITS=32
ifeq (x86_64,$(shell uname -m))
BITS=64
endif
# msys will always be 32 bit so look at the cpu arch instead.
ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
	ifeq (1,$(MINGW))
		BITS=64
	endif
endif
BITS_FLAG =

ifeq (32,$(BITS))
	BITS_FLAG = -m32
endif

ifeq (64,$(BITS))
	BITS_FLAG = -m64
endif
SSE_FLAG=-msse2

DEBUG_FLAGS    = -O0 -g3 $(BIToS_FLAG) $(SSE_FLAG)
DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(EXTRA_FLAGS)\""
RELEASE_FLAGS  = -O3 $(BITS_FLAG) $(SSE_FLAG) -funroll-loops -g3
RELEASE_DEFS   = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(EXTRA_FLAGS)\""
NOASSERT_FLAGS = -DNDEBUG
FILE_FLAGS     = -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE

ifeq (1,$(USE_SRA))
	ifeq (1, $(MACOS))
		DEBUG_FLAGS += -mmacosx-version-min=10.6
		RELEASE_FLAGS += -mmacosx-version-min=10.6
	endif
endif


HISAT2_BIN_LIST = hisat2-build-s \
	hisat2-build-l \
	hisat2-align-s \
	hisat2-align-l \
	hisat2-inspect-s \
	hisat2-inspect-l
HISAT2_BIN_LIST_AUX = hisat2-build-s-debug \
	hisat2-build-l-debug \
	hisat2-align-s-debug \
	hisat2-align-l-debug \
	hisat2-inspect-s-debug \
	hisat2-inspect-l-debug

GENERAL_LIST = $(wildcard scripts/*.sh) \
	$(wildcard scripts/*.pl) \
	$(wildcard *.py) \
	doc/manual.inc.html \
	doc/README \
	doc/style.css \
	$(wildcard example/index/*.ht2) \
	$(wildcard example/reads/*.fa) \
	example/reference/22_20-21M.fa \
	example/reference/22_20-21M.snp \
	$(PTHREAD_PKG) \
	hisat2 \
	hisat2-build \
	hisat2-inspect \
	AUTHORS \
	LICENSE \
	NEWS \
	MANUAL \
	MANUAL.markdown \
	TUTORIAL \
	VERSION

ifeq (1,$(WINDOWS))
	HISAT2_BIN_LIST := $(HISAT2_BIN_LIST) hisat2.bat hisat2-build.bat hisat2-inspect.bat 
endif

# This is helpful on Windows under MinGW/MSYS, where Make might go for
# the Windows FIND tool instead.
FIND=$(shell which find)

SRC_PKG_LIST = $(wildcard *.h) \
	$(wildcard *.hh) \
	$(wildcard *.c) \
	$(wildcard *.cpp) \
	doc/strip_markdown.pl \
	Makefile \
	$(GENERAL_LIST)

BIN_PKG_LIST = $(GENERAL_LIST)

.PHONY: all allall both both-debug

all: $(HISAT2_BIN_LIST)

allall: $(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX)

both: hisat2-align-s hisat2-align-l hisat2-build-s hisat2-build-l

both-debug: hisat2-align-s-debug hisat2-align-l-debug hisat2-build-s-debug hisat2-build-l-debug

DEFS=-fno-strict-aliasing \
     -DHISAT2_VERSION="\"`cat VERSION`\"" \
     -DBUILD_HOST="\"`hostname`\"" \
     -DBUILD_TIME="\"`date`\"" \
     -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
     $(FILE_FLAGS) \
     $(PREF_DEF) \
     $(MM_DEF) \
     $(SHMEM_DEF)

#
# hisat-bp targets
#

hisat-bp-bin: hisat_bp.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
	$(INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(HISAT_CPPS_MAIN) \
	$(LIBS) $(SEARCH_LIBS)

hisat-bp-bin-debug: hisat_bp.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
	$(DEBUG_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DBOWTIE2 -Wall \
	$(INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(HISAT_CPPS_MAIN) \
	$(LIBS) $(SEARCH_LIBS)


#
# hisat2-build targets
#

hisat2-build-s: hisat2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall -DMASSIVE_DATA_RLCSA \
	$(INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(HISAT2_BUILD_CPPS_MAIN) \
	$(LIBS) $(BUILD_LIBS)

hisat2-build-l: hisat2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
	$(INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(HISAT2_BUILD_CPPS_MAIN) \
	$(LIBS) $(BUILD_LIBS)

hisat2-build-s-debug: hisat2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DBOWTIE2 -Wall -DMASSIVE_DATA_RLCSA \
	$(INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(HISAT2_BUILD_CPPS_MAIN) \
	$(LIBS) $(BUILD_LIBS)

hisat2-build-l-debug: hisat2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
	$(INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(HISAT2_BUILD_CPPS_MAIN) \
	$(LIBS) $(BUILD_LIBS)

#
# hisat2 targets
#

hisat2-align-s: hisat2.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) $(SRA_DEF) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
	$(INC) $(SEARCH_INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(HISAT2_CPPS_MAIN) \
	$(LIBS) $(SRA_LIB) $(SEARCH_LIBS)

hisat2-align-l: hisat2.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) $(SRA_DEF) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
	$(INC) $(SEARCH_INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(HISAT2_CPPS_MAIN) \
	$(LIBS) $(SRA_LIB) $(SEARCH_LIBS)

hisat2-align-s-debug: hisat2.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
	$(DEBUG_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) $(SRA_DEF) -DBOWTIE2 -Wall \
	$(INC) $(SEARCH_INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(HISAT2_CPPS_MAIN) \
	$(LIBS) $(SRA_LIB) $(SEARCH_LIBS)

hisat2-align-l-debug: hisat2.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
	$(DEBUG_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) $(SRA_DEF) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
	$(INC) $(SEARCH_INC) \
	-o $@ $< \
	$(SHARED_CPPS) $(HISAT2_CPPS_MAIN) \
	$(LIBS) $(SRA_LIB) $(SEARCH_LIBS)

#
# hisat2-inspect targets
#

hisat2-inspect-s: hisat2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
	$(RELEASE_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DBOWTIE2 -DHISAT2_INSPECT_MAIN -Wall \
	$(INC) -I . \
	-o $@ $< \
	$(SHARED_CPPS) \
	$(LIBS) $(INSPECT_LIBS)

hisat2-inspect-l: hisat2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
	$(RELEASE_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -DHISAT2_INSPECT_MAIN -Wall \
	$(INC) -I . \
	-o $@ $< \
	$(SHARED_CPPS) \
	$(LIBS) $(INSPECT_LIBS)

hisat2-inspect-s-debug: hisat2_inspect.cpp $(HEADERS) $(SHARED_CPPS) 
	$(CXX) $(DEBUG_FLAGS) \
	$(DEBUG_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DBOWTIE2 -DHISAT2_INSPECT_MAIN -Wall \
	$(INC) -I . \
	-o $@ $< \
	$(SHARED_CPPS) \
	$(LIBS) $(INSPECT_LIBS)

hisat2-inspect-l-debug: hisat2_inspect.cpp $(HEADERS) $(SHARED_CPPS) 
	$(CXX) $(DEBUG_FLAGS) \
	$(DEBUG_DEFS) $(EXTRA_FLAGS) \
	$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -DHISAT2_INSPECT_MAIN -Wall \
	$(INC) -I . \
	-o $@ $< \
	$(SHARED_CPPS) \
	$(LIBS) $(INSPECT_LIBS)



hisat2: ;

hisat2.bat:
	echo "@echo off" > hisat2.bat
	echo "perl %~dp0/hisat2 %*" >> hisat2.bat

hisat2-build.bat:
	echo "@echo off" > hisat2-build.bat
	echo "python %~dp0/hisat2-build %*" >> hisat2-build.bat

hisat2-inspect.bat:
	echo "@echo off" > hisat2-inspect.bat
	echo "python %~dp0/hisat2-inspect %*" >> hisat2-inspect.bat


.PHONY: hisat2-src
hisat2-src: $(SRC_PKG_LIST)
	chmod a+x scripts/*.sh scripts/*.pl
	mkdir .src.tmp
	mkdir .src.tmp/hisat2-$(VERSION)
	zip tmp.zip $(SRC_PKG_LIST)
	mv tmp.zip .src.tmp/hisat2-$(VERSION)
	cd .src.tmp/hisat2-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
	cd .src.tmp ; zip -r hisat2-$(VERSION)-source.zip hisat2-$(VERSION)
	cp .src.tmp/hisat2-$(VERSION)-source.zip .
	rm -rf .src.tmp

.PHONY: hisat2-bin
hisat2-bin: $(BIN_PKG_LIST) $(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX)
	chmod a+x scripts/*.sh scripts/*.pl
	rm -rf .bin.tmp
	mkdir .bin.tmp
	mkdir .bin.tmp/hisat2-$(VERSION)
	if [ -f hisat2.exe ] ; then \
		zip tmp.zip $(BIN_PKG_LIST) $(addsuffix .exe,$(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX)) ; \
	else \
		zip tmp.zip $(BIN_PKG_LIST) $(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX) ; \
	fi
	mv tmp.zip .bin.tmp/hisat2-$(VERSION)
	cd .bin.tmp/hisat2-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
	cd .bin.tmp ; zip -r hisat2-$(VERSION)-$(BITS).zip hisat2-$(VERSION)
	cp .bin.tmp/hisat2-$(VERSION)-$(BITS).zip .
	rm -rf .bin.tmp

.PHONY: doc
doc: doc/manual.inc.html MANUAL

doc/manual.inc.html: MANUAL.markdown
	pandoc -T "HISAT2 Manual" -o $@ \
	 --from markdown --to HTML --toc $^
	perl -i -ne \
	 '$$w=0 if m|^</body>|;print if $$w;$$w=1 if m|^<body>|;' $@

MANUAL: MANUAL.markdown
	perl doc/strip_markdown.pl < $^ > $@

.PHONY: clean
clean:
	rm -f $(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX) \
	$(addsuffix .exe,$(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX)) \
	hisat2-src.zip hisat2-bin.zip
	rm -f core.* .tmp.head
	rm -rf *.dSYM

.PHONY: push-doc
push-doc: doc/manual.inc.html
	scp doc/*.*html igm1:/data1/igm3/www/ccb.jhu.edu/html/software/hisat2/

## hisat2 2.0.4

=== debian/changelog ===
hisat2 (2.0.4-2) unstable; urgency=medium

  * Team upload.
  * Fix Vcs-Git.
  * Fix build on kFreeBSD. Thanks to Steven Chamberlain for the patch.
    Closes: #834864
  * Make build reproducible.
    - Set C(XX,PP)FLAGS to make sure -fdebug-prefix-map is set.
    - Set TZ=UTC.
  * Remove arch-restrictive compiler flags.
    Closes: #834862

 -- Sascha Steinbiss <satta@debian.org>  Thu, 25 Aug 2016 15:46:42 +0000

hisat2 (2.0.4-1) unstable; urgency=medium

  * Initial release. (Closes: #834592)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 17 Aug 2016 05:15:40 -0700

=== debian/control ===
Source: hisat2
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
Build-Depends: debhelper (>= 9),
               help2man,
               pandoc,
               python
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/hisat2.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/hisat2.git
Homepage: https://ccb.jhu.edu/software/hisat2/index.shtml

Package: hisat2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, python
Description: graph-based alignment of short nucleotide reads to many genomes
 HISAT2 is a fast and sensitive alignment program for mapping next-generation
 sequencing reads (both DNA and RNA) to a population of human genomes (as well
 as against a single reference genome). Based on an extension of BWT for graphs
 a graph FM index (GFM) was designed and implementd. In addition to using
 one global GFM index that represents a population of human genomes, HISAT2
 uses a large set of small GFM indexes that collectively cover the whole genome
 (each index representing a genomic region of 56 Kbp, with 55,000 indexes
 needed to cover the human population). These small indexes (called local
 indexes), combined with several alignment strategies, enable rapid and
 accurate alignment of sequencing reads. This new indexing scheme is called a
 Hierarchical Graph FM index (HGFM).

=== debian/watch ===
version=3
opts=pasv \
      ftp://ftp.ccb.jhu.edu/pub/infphilo/hisat2/downloads/hisat2-([0-9.]+)-source.zip

## hisat2 2.0.5

=== debian/changelog ===
hisat2 (2.0.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Architecture: amd64 kfreebsd-amd64
    Closes: #834862, #834863
  * d/watch:
     - version=4
     - xz compression
  * debhelper 10

 -- Andreas Tille <tille@debian.org>  Fri, 09 Dec 2016 13:45:26 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                help2man,
                pandoc,
                python
@@ -13,7 +13,7 @@
 Homepage: https://ccb.jhu.edu/software/hisat2/index.shtml
 
 Package: hisat2
-Architecture: any
+Architecture: amd64 kfreebsd-amd64
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, python
 Description: graph-based alignment of short nucleotide reads to many genomes
  HISAT2 is a fast and sensitive alignment program for mapping next-generation

## hisat2 2.1.0

=== Makefile ===
--- 
+++ 
@@ -186,6 +186,8 @@
 GENERAL_LIST = $(wildcard scripts/*.sh) \
 	$(wildcard scripts/*.pl) \
 	$(wildcard *.py) \
+	$(wildcard hisatgenotype_modules/*.py) \
+	$(wildcard hisatgenotype_scripts/*.py) \
 	doc/manual.inc.html \
 	doc/README \
 	doc/style.css \

=== debian/changelog ===
hisat2 (2.1.0-2nopython3hisat3) unstable; urgency=medium

  * armhf armel ppc64el s390x: add -Wno-narrowing

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 04 Jan 2020 22:52:02 +0100

hisat2 (2.1.0-2nopython3hisat2) unstable; urgency=medium

  [ Saira Hussain ]
  * Add autopkgtest

  [ Andreas Tille ]
  * Install hisat2_extract_splice_sites.py
  * Recommends: bcftools, samtools

  [ Michael R. Crusoe ]
  * Skip the new python3-hisat2 package while we wait for 2.1.0-3 to go
    through the NEW queue.
  * Include SIMD everywhere headers and enable building on all architectures.
  * debhelper-compat 12
  * Remove trailing whitespace in debian/control
  * Ported Python scripts to Python 3 using 2to3. Closes: #943125

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 30 Dec 2019 20:08:00 +0100

hisat2 (2.1.0-2) unstable; urgency=medium

  * Team upload.
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * Fix wrong path for Perl interpreter
  * Do not parse d/changelog

 -- Andreas Tille <tille@debian.org>  Mon, 24 Sep 2018 11:52:06 +0200

hisat2 (2.1.0-1) unstable; urgency=medium

  * Team upload

  [ Steffen Moeller ]
  * debian/upstream/metadata: Added ref to OMICtools

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.1.0 (no changes needed)

 -- Andreas Tille <tille@debian.org>  Mon, 04 Sep 2017 14:49:40 +0200

=== debian/control ===
Source: hisat2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               help2man,
               pandoc,
               python3
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/med-team/hisat2
Vcs-Git: https://salsa.debian.org/med-team/hisat2.git
Homepage: https://ccb.jhu.edu/software/hisat2/index.shtml

Package: hisat2
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${perl:Depends},
         python3
Recommends: python3-hisat2,
            bcftools,
            samtools
Description: graph-based alignment of short nucleotide reads to many genomes
 HISAT2 is a fast and sensitive alignment program for mapping next-generation
 sequencing reads (both DNA and RNA) to a population of human genomes (as well
 as against a single reference genome). Based on an extension of BWT for graphs
 a graph FM index (GFM) was designed and implementd. In addition to using
 one global GFM index that represents a population of human genomes, HISAT2
 uses a large set of small GFM indexes that collectively cover the whole genome
 (each index representing a genomic region of 56 Kbp, with 55,000 indexes
 needed to cover the human population). These small indexes (called local
 indexes), combined with several alignment strategies, enable rapid and
 accurate alignment of sequencing reads. This new indexing scheme is called a
 Hierarchical Graph FM index (HGFM).

# Package: python3-hisat2
# Section: python
# Architecture: all
# Depends: ${misc:Depends},
#          hisat2,
#          python3
# Description: Python scripts accompanying hisat2
#  HISAT2 is a fast and sensitive alignment program for mapping next-
#  generation sequencing reads (both DNA and RNA) to a population of human
#  genomes (as well as against a single reference genome). Based on an
#  extension of BWT for graphs a graph FM index (GFM) was designed and
#  implementd. In addition to using one global GFM index that represents a
#  population of human genomes, HISAT2 uses a large set of small GFM
#  indexes that collectively cover the whole genome (each index
#  representing a genomic region of 56 Kbp, with 55,000 indexes needed to
#  cover the human population). These small indexes (called local indexes),
#  combined with several alignment strategies, enable rapid and accurate
#  alignment of sequencing reads. This new indexing scheme is called a
#  Hierarchical Graph FM index (HGFM).
#  .
#  This package provides a serires of platform-independent scripts that are
#  typically expected to be co-installed with the hisat2 binary.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export TZ=UTC

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_CXXFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3

ifneq (,$(filter arm64 armhf armel ppc64el s390x,$(DEB_BUILD_ARCH)))
export DEB_CFLAGS_MAINT_APPEND += -Wno-narrowing
export DEB_CXXFLAGS_MAINT_APPEND += -Wno-narrowing
endif

ifneq (,$(filter amd64,$(DEB_BUILD_ARCH)))
export DEB_CFLAGS_MAINT_APPEND += -DPOPCNT_CAPABILITY
export DEB_CXXFLAGS_MAINT_APPEND += -DPOPCNT_CAPABILITY
endif


DATE=$(shell date --date=@$(SOURCE_DATE_EPOCH) '+%d %B %Y')

%:
	dh $@

override_dh_auto_build:
	dh_auto_build --  BUILD_HOST='Debian' BUILD_TIME="$(DATE)" all doc
	help2man ./hisat2 --no-info --name \
		'graph-based alignment of short nucleotide reads to many genomes, wrapper script' \
		> debian/hisat2.1
	help2man ./hisat2-align-l --name 'HISAT2 graph-based alignment of short nucleotide reads to many genomes, large index binary' \
		--no-info > debian/hisat2-align-l.1
	help2man ./hisat2-align-s --name 'HISAT2 graph-based alignment of short nucleotide reads to many genomes, small index binary' \
		--no-info > debian/hisat2-align-s.1
	help2man ./hisat2-build --name 'HISAT2 indexer, wrapper script' \
		--no-info > debian/hisat2-build.1
	#rm hisat2-buildc
	help2man ./hisat2-build-l --name 'HISAT2 indexer, large index binary' \
		--no-info > debian/hisat2-build-l.1
	help2man ./hisat2-build-s --name 'HISAT2 indexer, small index binary' \
		--no-info > debian/hisat2-build-s.1
	help2man ./hisat2-inspect --name 'HISAT2 index inspector, wrapper script' \
		--no-info > debian/hisat2-inspect.1
	help2man ./hisat2-inspect-l --name 'HISAT2 index inspector, large index binary' \
		--no-info > debian/hisat2-inspect-l.1
	help2man ./hisat2-inspect-s --name 'HISAT2 index inspector, small index binary' \
		--no-info > debian/hisat2-inspect-s.1

override_dh_install:
	dh_install
	for pl in `grep -Rl '#!/usr/bin/env[[:space:]]\+perl' debian/*/usr/*` ; do \
	    sed -i '1s?^#!/usr/bin/env[[:space:]]\+perl?#!/usr/bin/perl?' $${pl} ; \
	done

=== debian/watch ===
version=4
opts="pasv,repack,compression=xz" \
      ftp://ftp.ccb.jhu.edu/pub/infphilo/hisat2/downloads/hisat2-([0-9.]+)-source.zip

# Download tarball is very strangely named on Github - this will not work
# https://github.com/infphilo/hisat2/releases .*/archive/@ANY_VERSION@@ARCHIVE_EXT@

## hisat2 2.2.0

=== Makefile ===
--- 
+++ 
@@ -55,8 +55,8 @@
 	MACOS = 1
 endif
 
-EXTRA_FLAGS += -DPOPCNT_CAPABILITY
-INC += -I third_party
+EXTRA_FLAGS += -DPOPCNT_CAPABILITY -std=c++11
+INC += -I. -I third_party 
 
 MM_DEF = 
 
@@ -127,8 +127,27 @@
 
 BUILD_CPPS = diff_sample.cpp
 
+REPEAT_CPPS = \
+	mask.cpp \
+	qual.cpp \
+	aligner_bt.cpp \
+	scoring.cpp \
+	simple_func.cpp \
+	dp_framer.cpp \
+	aligner_result.cpp \
+	aligner_sw_driver.cpp \
+	aligner_sw.cpp \
+	aligner_swsse_ee_i16.cpp \
+	aligner_swsse_ee_u8.cpp \
+	aligner_swsse_loc_i16.cpp \
+	aligner_swsse_loc_u8.cpp \
+	aligner_swsse.cpp \
+	bit_packed_array.cpp \
+	repeat_builder.cpp
+
 HISAT2_CPPS_MAIN = $(SEARCH_CPPS) hisat2_main.cpp
 HISAT2_BUILD_CPPS_MAIN = $(BUILD_CPPS) hisat2_build_main.cpp
+HISAT2_REPEAT_CPPS_MAIN = $(REPEAT_CPPS) $(BUILD_CPPS) hisat2_repeat_main.cpp
 
 SEARCH_FRAGMENTS = $(wildcard search_*_phase*.c)
 VERSION = $(shell cat VERSION)
@@ -155,7 +174,7 @@
 endif
 SSE_FLAG=-msse2
 
-DEBUG_FLAGS    = -O0 -g3 $(BIToS_FLAG) $(SSE_FLAG)
+DEBUG_FLAGS    = -O0 -g3 $(BITS_FLAG) $(SSE_FLAG)
 DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(EXTRA_FLAGS)\""
 RELEASE_FLAGS  = -O3 $(BITS_FLAG) $(SSE_FLAG) -funroll-loops -g3
 RELEASE_DEFS   = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(EXTRA_FLAGS)\""
@@ -164,8 +183,9 @@
 
 ifeq (1,$(USE_SRA))
 	ifeq (1, $(MACOS))
-		DEBUG_FLAGS += -mmacosx-version-min=10.6
-		RELEASE_FLAGS += -mmacosx-version-min=10.6
+		SRA_LIB += -stdlib=libc++
+		DEBUG_FLAGS += -mmacosx-version-min=10.10
+		RELEASE_FLAGS += -mmacosx-version-min=10.10
 	endif
 endif
 
@@ -175,22 +195,50 @@
 	hisat2-align-s \
 	hisat2-align-l \
 	hisat2-inspect-s \
-	hisat2-inspect-l
+	hisat2-inspect-l \
+	hisat2-repeat
 HISAT2_BIN_LIST_AUX = hisat2-build-s-debug \
 	hisat2-build-l-debug \
 	hisat2-align-s-debug \
 	hisat2-align-l-debug \
 	hisat2-inspect-s-debug \
-	hisat2-inspect-l-debug
+	hisat2-inspect-l-debug \
+	hisat2-repeat-debug
+
+HT2LIB_DIR = hisat2lib
+HT2LIB_SRCS = $(SHARED_CPPS) \
+			  $(HT2LIB_DIR)/ht2_init.cpp \
+			  $(HT2LIB_DIR)/ht2_repeat.cpp \
+			  $(HT2LIB_DIR)/ht2_index.cpp
+
+HT2LIB_OBJS = $(HT2LIB_SRCS:.cpp=.o)
+
+HT2LIB_DEBUG_OBJS = $(addprefix .ht2lib-obj-debug/,$(HT2LIB_OBJS))
+HT2LIB_RELEASE_OBJS = $(addprefix .ht2lib-obj-release/,$(HT2LIB_OBJS))
+HT2LIB_SHARED_DEBUG_OBJS = $(addprefix .ht2lib-obj-debug-shared/,$(HT2LIB_OBJS))
+HT2LIB_SHARED_RELEASE_OBJS = $(addprefix .ht2lib-obj-release-shared/,$(HT2LIB_OBJS))
+
+HT2LIB_PKG_SRC = \
+	$(HT2LIB_DIR)/ht2_init.cpp \
+	$(HT2LIB_DIR)/ht2_repeat.cpp \
+	$(HT2LIB_DIR)/ht2_index.cpp \
+	$(HT2LIB_DIR)/ht2.h \
+	$(HT2LIB_DIR)/ht2_handle.h \
+	$(HT2LIB_DIR)/java_jni/Makefile \
+	$(HT2LIB_DIR)/java_jni/ht2module.c \
+	$(HT2LIB_DIR)/java_jni/HT2Module.java \
+	$(HT2LIB_DIR)/java_jni/HT2ModuleExample.java \
+	$(HT2LIB_DIR)/pymodule/Makefile \
+	$(HT2LIB_DIR)/pymodule/ht2module.c \
+	$(HT2LIB_DIR)/pymodule/setup.py \
+	$(HT2LIB_DIR)/pymodule/ht2example.py
+
 
 GENERAL_LIST = $(wildcard scripts/*.sh) \
 	$(wildcard scripts/*.pl) \
 	$(wildcard *.py) \
 	$(wildcard hisatgenotype_modules/*.py) \
 	$(wildcard hisatgenotype_scripts/*.py) \
-	doc/manual.inc.html \
-	doc/README \
-	doc/style.css \
 	$(wildcard example/index/*.ht2) \
 	$(wildcard example/reads/*.fa) \
 	example/reference/22_20-21M.fa \
@@ -219,8 +267,9 @@
 	$(wildcard *.hh) \
 	$(wildcard *.c) \
 	$(wildcard *.cpp) \
-	doc/strip_markdown.pl \
+	$(HT2LIB_PKG_SRC) \
 	Makefile \
+	CMakeLists.txt \
 	$(GENERAL_LIST)
 
 BIN_PKG_LIST = $(GENERAL_LIST)
@@ -234,6 +283,10 @@
 both: hisat2-align-s hisat2-align-l hisat2-build-s hisat2-build-l
 
 both-debug: hisat2-align-s-debug hisat2-align-l-debug hisat2-build-s-debug hisat2-build-l-debug
+
+repeat: hisat2-repeat
+
+repeat-debug: hisat2-repeat-debug
 
 DEFS=-fno-strict-aliasing \
      -DHISAT2_VERSION="\"`cat VERSION`\"" \
@@ -266,6 +319,26 @@
 	$(SHARED_CPPS) $(HISAT_CPPS_MAIN) \
 	$(LIBS) $(SEARCH_LIBS)
 
+#
+# hisat2-repeat targets
+#
+
+hisat2-repeat: hisat2_repeat.cpp $(REPEAT_CPPS) $(SHARED_CPPS) $(HEADERS)
+	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
+	$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
+	$(INC) \
+	-o $@ $< \
+	$(SHARED_CPPS) $(HISAT2_REPEAT_CPPS_MAIN) \
+	$(LIBS) $(BUILD_LIBS)
+
+hisat2-repeat-debug: hisat2_repeat.cpp $(REPEAT_CPPS) $(SHARED_CPPS) $(HEADERS)
+	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
+	$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
+	$(INC) \
+	-o $@ $< \
+	$(SHARED_CPPS) $(HISAT2_REPEAT_CPPS_MAIN) \
+	$(LIBS) $(BUILD_LIBS)
+
 
 #
 # hisat2-build targets
@@ -381,72 +454,9 @@
 	$(SHARED_CPPS) \
 	$(LIBS) $(INSPECT_LIBS)
 
-
-
-hisat2: ;
-
-hisat2.bat:
-	echo "@echo off" > hisat2.bat
-	echo "perl %~dp0/hisat2 %*" >> hisat2.bat
-
-hisat2-build.bat:
-	echo "@echo off" > hisat2-build.bat
-	echo "python %~dp0/hisat2-build %*" >> hisat2-build.bat
-
-hisat2-inspect.bat:
-	echo "@echo off" > hisat2-inspect.bat
-	echo "python %~dp0/hisat2-inspect %*" >> hisat2-inspect.bat
-
-
-.PHONY: hisat2-src
-hisat2-src: $(SRC_PKG_LIST)
-	chmod a+x scripts/*.sh scripts/*.pl
-	mkdir .src.tmp
-	mkdir .src.tmp/hisat2-$(VERSION)
-	zip tmp.zip $(SRC_PKG_LIST)
-	mv tmp.zip .src.tmp/hisat2-$(VERSION)
-	cd .src.tmp/hisat2-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
-	cd .src.tmp ; zip -r hisat2-$(VERSION)-source.zip hisat2-$(VERSION)
-	cp .src.tmp/hisat2-$(VERSION)-source.zip .
-	rm -rf .src.tmp
-
-.PHONY: hisat2-bin
-hisat2-bin: $(BIN_PKG_LIST) $(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX)
-	chmod a+x scripts/*.sh scripts/*.pl
-	rm -rf .bin.tmp
-	mkdir .bin.tmp
-	mkdir .bin.tmp/hisat2-$(VERSION)
-	if [ -f hisat2.exe ] ; then \
-		zip tmp.zip $(BIN_PKG_LIST) $(addsuffix .exe,$(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX)) ; \
-	else \
-		zip tmp.zip $(BIN_PKG_LIST) $(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX) ; \
-	fi
-	mv tmp.zip .bin.tmp/hisat2-$(VERSION)
-	cd .bin.tmp/hisat2-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
-	cd .bin.tmp ; zip -r hisat2-$(VERSION)-$(BITS).zip hisat2-$(VERSION)
-	cp .bin.tmp/hisat2-$(VERSION)-$(BITS).zip .
-	rm -rf .bin.tmp
-
-.PHONY: doc
-doc: doc/manual.inc.html MANUAL
-
-doc/manual.inc.html: MANUAL.markdown
-	pandoc -T "HISAT2 Manual" -o $@ \
-	 --from markdown --to HTML --toc $^
-	perl -i -ne \
-	 '$$w=0 if m|^</body>|;print if $$w;$$w=1 if m|^<body>|;' $@
-
-MANUAL: MANUAL.markdown
-	perl doc/strip_markdown.pl < $^ > $@
-
-.PHONY: clean
-clean:
-	rm -f $(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX) \
-	$(addsuffix .exe,$(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX)) \
-	hisat2-src.zip hisat2-bin.zip
-	rm -f core.* .tmp.head
-	rm -rf *.dSYM
-
-.PHONY: push-doc
-push-doc: doc/manual.inc.html
-	scp doc/*.*html igm1:/data1/igm3/www/ccb.jhu.edu/html/software/hisat2/
+#
+# HT2LIB targets
+#
+
+ht2lib: libhisat2lib-debug.a libhisat2lib.a libhisat2lib-debug.so libhisat2lib.so
+

=== debian/changelog ===
hisat2 (2.2.0-2) unstable; urgency=medium

  * Fix simde patch for ppc64el
  * Fix missing $(LDFLAGS) in hardening patch

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 06 May 2020 20:48:11 +0200

hisat2 (2.2.0-1) unstable; urgency=medium

  * Use the libsimde-dev package instead of our code copy.
  * Standards-Version: 4.5.0 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Upstream moved to GitHub
  * Use the HISAT2 citation instead of the HISAT paper
  * New upstream version
  * Freshen the patches
  * Added patch to fix the manual path

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 19 Apr 2020 23:04:26 +0200

hisat2 (2.1.0-4) unstable; urgency=medium

  * Integrate recent changes with the new python3-hisat2 package.
  * Made it easier to cross build the package

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 11 Feb 2020 18:22:17 +0100

=== debian/control ===
Source: hisat2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               libsimde-dev,
               help2man <!nodoc>,
               pandoc <!nodoc>,
               python3:any <!nodoc>
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/hisat2
Vcs-Git: https://salsa.debian.org/med-team/hisat2.git
Homepage: https://daehwankimlab.github.io/hisat2/
Rules-Requires-Root: no

Package: hisat2
Architecture: any
Built-Using: ${simde:Built-Using}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${perl:Depends},
         python3
Recommends: python3-hisat2,
            bcftools,
            samtools
Description: graph-based alignment of short nucleotide reads to many genomes
 HISAT2 is a fast and sensitive alignment program for mapping next-generation
 sequencing reads (both DNA and RNA) to a population of human genomes (as well
 as against a single reference genome). Based on an extension of BWT for graphs
 a graph FM index (GFM) was designed and implementd. In addition to using
 one global GFM index that represents a population of human genomes, HISAT2
 uses a large set of small GFM indexes that collectively cover the whole genome
 (each index representing a genomic region of 56 Kbp, with 55,000 indexes
 needed to cover the human population). These small indexes (called local
 indexes), combined with several alignment strategies, enable rapid and
 accurate alignment of sequencing reads. This new indexing scheme is called a
 Hierarchical Graph FM index (HGFM).

Package: python3-hisat2
Section: python
Architecture: all
Built-Using: ${simde:Built-Using}
Depends: ${misc:Depends},
         hisat2,
         python3
Description: Python scripts accompanying hisat2
 HISAT2 is a fast and sensitive alignment program for mapping next-
 generation sequencing reads (both DNA and RNA) to a population of human
 genomes (as well as against a single reference genome). Based on an
 extension of BWT for graphs a graph FM index (GFM) was designed and
 implementd. In addition to using one global GFM index that represents a
 population of human genomes, HISAT2 uses a large set of small GFM
 indexes that collectively cover the whole genome (each index
 representing a genomic region of 56 Kbp, with 55,000 indexes needed to
 cover the human population). These small indexes (called local indexes),
 combined with several alignment strategies, enable rapid and accurate
 alignment of sequencing reads. This new indexing scheme is called a
 Hierarchical Graph FM index (HGFM).
 .
 This package provides a serires of platform-independent scripts that are
 typically expected to be co-installed with the hisat2 binary.

=== debian/tests/control ===
Tests: run-unit-tests
Depends: @, samtools, bcftools
Restrictions: allow-stderr

## hisat2 2.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(hisat2)

# escape preprocessor definition 
cmake_policy(SET CMP0005 NEW)

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE Release)
endif()

option(BOWTIE_MM "enable memory mapping" ON)
option(BOWTIE_SHARED_MEM "enable shared memory mapping" OFF)
option(USE_SRA "enable NCBI SRA Toolkit" OFF)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_VERBOSE_MAKEFILE true)
set(CMAKE_EXPORT_COMPILE_COMMANDS on)
set(NCBI_NGS_DIR ${NCBI_NGS_DIR})

# Common Flag
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64 -g3 -Wall -msse2")

# Debug/Release Flag
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -funroll-loops")

set(INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE PATH "Installation directory for executables")

if(MINGW OR CYGWIN)
    option(BOWTIE_MM "Memory mapped files not supported on Windows" OFF)
    option(BOWTIE_SHARED_MEM "Shared memory not supported on Windows" OFF)
endif()
 
if (USE_SRA AND APPLE)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mmacosx-version-min=10.6")
endif()

set(HISAT2_BIN_LIST
	hisat2-build-s
	hisat2-build-l
	hisat2-align-s
	hisat2-align-l
	hisat2-inspect-s
	hisat2-inspect-l
	hisat2-repeat
    )

set(HISAT2_LIB_LIST
	hisat2lib
	)


# Source Codes
set(SHARED_CPPS
	alphabet.cpp
	ccnt_lut.cpp
	ds.cpp
	edit.cpp
	gfm.cpp
	limit.cpp
	multikey_qsort.cpp
	random_source.cpp
	reference.cpp
	ref_read.cpp
	shmem.cpp
	tinythread.cpp
	)

set(SEARCH_CPPS
	aligner_bt.cpp
	aligner_cache.cpp
	aligner_driver.cpp
	aligner_result.cpp
	aligner_seed.cpp
	aligner_seed2.cpp
	aligner_seed_policy.cpp
	aligner_sw.cpp
	aligner_sw_driver.cpp
	aligner_swsse.cpp
	aligner_swsse_ee_i16.cpp
	aligner_swsse_ee_u8.cpp
	aligner_swsse_loc_i16.cpp
	aligner_swsse_loc_u8.cpp
	aln_sink.cpp
	dp_framer.cpp
	outq.cpp
	pat.cpp
	pe.cpp
	presets.cpp
	qual.cpp
	random_util.cpp
	read_qseq.cpp
	ref_coord.cpp mask.cpp
	scoring.cpp
	simple_func.cpp
	splice_site.cpp
	sse_util.cpp
	unique.cpp
	hisat2_main.cpp
	hisat2.cpp
	)

set(BUILD_CPPS
	diff_sample.cpp
	hisat2_build_main.cpp
	hisat2_build.cpp
	)

set(REPEAT_CPPS
	aligner_bt.cpp
	aligner_result.cpp
	aligner_sw_driver.cpp
	aligner_sw.cpp
	aligner_swsse_ee_i16.cpp
	aligner_swsse_ee_u8.cpp
	aligner_swsse_loc_i16.cpp
	aligner_swsse_loc_u8.cpp
	aligner_swsse.cpp
	bit_packed_array.cpp
	bit_packed_array.h
	dp_framer.cpp
	mask.cpp
	qual.cpp
	repeat_builder.cpp
	scoring.cpp
	simple_func.cpp
	diff_sample.cpp
	hisat2_repeat_main.cpp
	hisat2_repeat.cpp
	)

set(INSPECT_CPPS
	hisat2_inspect.cpp
	)


set(HT2LIB_CPPS
	hisat2lib/ht2_init.cpp
	hisat2lib/ht2_repeat.cpp
	hisat2lib/ht2_index.cpp
	)


string(TIMESTAMP BUILD_DATE)
file(STRINGS VERSION HISAT2_VERSION)
execute_process(COMMAND ${CMAKE_CXX_COMPILER} -v OUTPUT_VARIABLE COMPILER_VERSION)

add_definitions(
	-DBOWTIE2
    -DBUILD_HOST="${CMAKE_HOST_SYSTEM}"
	-DBUILD_TIME="${BUILD_DATE}"
    -DCOMPILER_VERSION="${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_VERSION}"
    -DHISAT2_VERSION="${HISAT2_VERSION}"
	-D_LARGEFILE_SOURCE
	-D_FILE_OFFSET_BITS=64
	-D_GNU_SOURCE
	-DPOPCNT_CAPABILITY
	)


include_directories(third_party)

link_libraries(
	pthread
	)


if(BOWTIE_MM)
	add_definitions(-DBOWTIE_MM)
endif()

if(BOWTIE_SHARED_MEM)
	add_definitions(-DBOWTIE_SHARED_MEM)
endif()

include_directories(${PROJECT_SOURCE_DIR})
add_definitions(-DCOMPILER_OPTIONS="${CMAKE_CXX_FLAGS}")

add_library(hisat2lib_static STATIC ${HT2LIB_CPPS} ${SHARED_CPPS})
add_library(hisat2lib_shared SHARED ${HT2LIB_CPPS} ${SHARED_CPPS})
add_custom_target(ht2lib)
add_dependencies(ht2lib hisat2lib_static hisat2lib_shared)

set_target_properties(hisat2lib_static PROPERTIES OUTPUT_NAME hisat2lib)
set_target_properties(hisat2lib_shared PROPERTIES OUTPUT_NAME hisat2lib)





add_executable(hisat2-align-s ${SEARCH_CPPS} ${SHARED_CPPS})
add_executable(hisat2-align-l ${SEARCH_CPPS} ${SHARED_CPPS})
add_executable(hisat2-build-s ${BUILD_CPPS} ${SHARED_CPPS})
add_executable(hisat2-build-l ${BUILD_CPPS} ${SHARED_CPPS})
add_executable(hisat2-inspect-s ${INSPECT_CPPS} ${SHARED_CPPS})
add_executable(hisat2-inspect-l ${INSPECT_CPPS} ${SHARED_CPPS})
add_executable(hisat2-repeat ${REPEAT_CPPS} ${SHARED_CPPS})
set_target_properties(${HISAT2_BIN_LIST} PROPERTIES DEBUG_POSTFIX "-debug")
set_target_properties(hisat2-align-l hisat2-build-l hisat2-inspect-l hisat2-repeat 
	PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS} -DBOWTIE_64BIT_INDEX")

target_compile_options(hisat2-inspect-s PUBLIC "-DHISAT2_INSPECT_MAIN")
target_compile_options(hisat2-inspect-l PUBLIC "-DHISAT2_INSPECT_MAIN")

target_compile_options(hisat2-build-s PUBLIC "-DMASSIVE_DATA_RLCSA")

target_compile_options(hisat2lib_static PUBLIC "-fPIC")
target_include_directories(hisat2lib_static PUBLIC hisat2lib)
target_include_directories(hisat2lib_shared PUBLIC hisat2lib)

if(USE_SRA)
	if(NOT NCBI_NGS_DIR)
		message(FATAL_ERROR "You should set NCBI_NGS_DIR path. cmake3 .... -DNCBI_NGS_DIR=/path/to/ngs")
	endif()
	#set(NCBI_NGS_DIR /home/parkch/.local/ngs)

	target_compile_options(hisat2-align-s PUBLIC "-DUSE_SRA")
	target_compile_options(hisat2-align-l PUBLIC "-DUSE_SRA")
	target_include_directories(hisat2-align-s PUBLIC "${NCBI_NGS_DIR}/include")
	target_include_directories(hisat2-align-l PUBLIC "${NCBI_NGS_DIR}/include")

	set(NCBI_LIBS 
		${NCBI_NGS_DIR}/lib64/libncbi-ngs-c++-static.a
		${NCBI_NGS_DIR}/lib64/libngs-c++-static.a
		${NCBI_NGS_DIR}/lib64/libncbi-vdb-static.a
		${CMAKE_DL_LIBS}
		)

	target_link_libraries(hisat2-align-s ${NCBI_LIBS})
	target_link_libraries(hisat2-align-l ${NCBI_LIBS})
endif()

add_custom_target(hisat2-all)
add_dependencies(hisat2-all
		hisat2-align-s
		hisat2-align-l
		hisat2-build-s
		hisat2-build-l
		hisat2-inspect-s
		hisat2-inspect-l
		hisat2-repeat)

#
# Examples
#
#target_compile_options(hisat2-inspect-s PUBLIC $<$<CONFIG:DEBUG>:-DDEBUGONLY>)
#target_compile_options(hisat2-inspect-s PUBLIC $<$<CONFIG:RELEASE>:-DRELEASEONLY>)

=== Makefile ===
--- 
+++ 
@@ -237,8 +237,6 @@
 GENERAL_LIST = $(wildcard scripts/*.sh) \
 	$(wildcard scripts/*.pl) \
 	$(wildcard *.py) \
-	$(wildcard hisatgenotype_modules/*.py) \
-	$(wildcard hisatgenotype_scripts/*.py) \
 	$(wildcard example/index/*.ht2) \
 	$(wildcard example/reads/*.fa) \
 	example/reference/22_20-21M.fa \
@@ -460,3 +458,6 @@
 
 ht2lib: libhisat2lib-debug.a libhisat2lib.a libhisat2lib-debug.so libhisat2lib.so
 
+libhisat2lib-debug.a: $(HT2LIB_DEBUG_OBJS)
+	ar rc $@ $(HT2LIB_DEBUG_OBJS) 
+

=== li_hla/Makefile ===
CXX = g++
CXXFLAGS= -W 
LINKPATH= -I./samtools-0.1.19 -L./samtools-0.1.19
LINKFLAGS = -lbam -lz -lm -lpthread 
DEBUG=
OBJECTS =

all: hla

hla: main.o 
	$(CXX) -o $@ $(LINKPATH) $(CXXFLAGS) $(OBJECTS) main.o $(LINKFLAGS)

main.o: main.cpp alignments.hpp

clean:
	rm -f *.o *.gch hla

=== hisat2lib/pymodule/Makefile ===
#
# Copyright 2018, Chanhee Park <parkchanhee@gmail.com> and Daehwan Kim <infphilo@gmail.com>
#
# This file is part of HISAT 2.
#
# HISAT 2 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# HISAT 2 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with HISAT 2.  If not, see <http://www.gnu.org/licenses/>.
#

all: lib

lib:
	ARCHFLAGS="-arch x86_64" python ./setup.py build

install:
	python ./setup.py install

clean:
	python ./setup.py clean
	rm -rf build test

test: lib
	python ./ht2example.py

=== debian/changelog ===
hisat2 (2.2.1-4) unstable; urgency=medium

  * Team upload
  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)
  * Update lintian-overrides

 -- Andreas Tille <tille@debian.org>  Fri, 14 Oct 2022 20:18:28 +0200

hisat2 (2.2.1-3) unstable; urgency=medium

  * Team upload.
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * Fix debian/source/lintian-overrides

 -- Andreas Tille <tille@debian.org>  Tue, 28 Sep 2021 10:35:43 +0200

hisat2 (2.2.1-2) unstable; urgency=medium

  * debian/patches/riscv5: fix compilation on riscv5
  * Standards-Version: 4.5.1 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 27 Jan 2021 17:34:32 +0100

hisat2 (2.2.1-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * Team upload.
  * New upstream version
  * debhelper-compat 13 (routine-update)

  [ Michael R. Crusoe ]
  * Refresh the patches

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 11 Aug 2020 13:42:31 +0200

=== debian/rules ===
--- 
+++ 
@@ -6,17 +6,16 @@
 
 include /usr/share/dpkg/default.mk
 
-# for hardening you might like to uncomment this:
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 export DEB_CFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
 export DEB_CXXFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
 
-ifneq (,$(filter arm64 armhf armel ppc64el s390x,$(DEB_BUILD_ARCH)))
+ifneq (,$(filter arm64 armhf armel ppc64el s390x,$(DEB_HOST_ARCH)))
 export DEB_CFLAGS_MAINT_APPEND += -Wno-narrowing
 export DEB_CXXFLAGS_MAINT_APPEND += -Wno-narrowing
 endif
 
-ifneq (,$(filter amd64,$(DEB_BUILD_ARCH)))
+ifneq (,$(filter amd64,$(DEB_HOST_ARCH)))
 export DEB_CFLAGS_MAINT_APPEND += -DPOPCNT_CAPABILITY
 export DEB_CXXFLAGS_MAINT_APPEND += -DPOPCNT_CAPABILITY
 endif
@@ -28,6 +27,7 @@
 	dh $@
 
 override_dh_auto_build:
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
 	dh_auto_build --  BUILD_HOST='Debian' BUILD_TIME="$(DATE)" all doc
 	help2man ./hisat2 --no-info --name \
 		'graph-based alignment of short nucleotide reads to many genomes, wrapper script' \
@@ -49,9 +49,15 @@
 		--no-info > debian/hisat2-inspect-l.1
 	help2man ./hisat2-inspect-s --name 'HISAT2 index inspector, small index binary' \
 		--no-info > debian/hisat2-inspect-s.1
+else
+	dh_auto_build --  BUILD_HOST='Debian' BUILD_TIME="$(DATE)" all
+endif
 
 override_dh_install:
 	dh_install
 	for pl in `grep -Rl '#!/usr/bin/env[[:space:]]\+perl' debian/*/usr/*` ; do \
 	    sed -i '1s?^#!/usr/bin/env[[:space:]]\+perl?#!/usr/bin/perl?' $${pl} ; \
 	done
+
+override_dh_gencontrol:
+	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/DaehwanKimLab/hisat2/tags .*/v@ANY_VERSION@\.tar\.gz
